BeagleWksDRParser Class Reference documentation

BeagleWksDRParser Class Referencefinal

the main class to read a BeagleWorks drawing file More...

`#include <BeagleWksDRParser.hxx>`

Inheritance diagram for BeagleWksDRParser:

## Public Member Functions
| BeagleWksDRParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~BeagleWksDRParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
void | newPage (int number)
| adds a new page
bool | createZones ()
| finds the different objects zones
bool | readRSRCZones ()
| read the resource fork zone
bool | sendPictures ()
| try to send the different pictures
bool | sendText (int id)
| try to send a text box content
bool | sendPageFrames ()
| try to send the page graphic
bool | sendFrame (BeagleWksStructManager::Frame const &frame)
| try to send a frame
bool | sendPicture (int pId, MWAWPosition const &pos, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle())
| try to send a picture
bool | readGraphicHeader ()
| try to read the graphic header
bool | readPatterns ()
| try to read the pattern zone
bool | readColors ()
| try to read the colors zone
bool | readArrows ()
| try to read the arrows zone (unknown format)
bool | readShapePositions ()
| try to read the shape position
bool | readShapeDefinitions ()
| try to read the shape definition
bool | readShapeDatas ()
| try to read the shape data
bool | readStyle (BeagleWksDRParserInternal::Shape &shape)
| try to read a style of a shape
bool | readPrintInfo ()
| read the print info zone
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< BeagleWksDRParserInternal::State > | m_state
| the state
std::shared_ptr< BeagleWksStructManager > | m_structureManager
| the structure manager

## Friends
class | BeagleWksDRParserInternal::SubDocument

## Detailed Description

the main class to read a BeagleWorks drawing file

## Constructor & Destructor Documentation

## ◆ BeagleWksDRParser()

BeagleWksDRParser::BeagleWksDRParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~BeagleWksDRParser()

BeagleWksDRParser::~BeagleWksDRParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool BeagleWksDRParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by BeagleWksDRParserInternal::SubDocument, and parse().

## ◆ createDocument()

void BeagleWksDRParser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by BeagleWksDRParserInternal::SubDocument, and parse().

## ◆ createZones()

bool BeagleWksDRParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by BeagleWksDRParserInternal::SubDocument, and parse().

## ◆ getPageLeftTop()

MWAWVec2f BeagleWksDRParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

Referenced by BeagleWksDRParserInternal::SubDocument.

## ◆ init()

void BeagleWksDRParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by BeagleWksDRParser(), and BeagleWksDRParserInternal::SubDocument.

## ◆ newPage()

void BeagleWksDRParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by BeagleWksDRParserInternal::SubDocument.

## ◆ parse()

void BeagleWksDRParser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWGraphicParser.

Referenced by BeagleWksDRParserInternal::SubDocument.

## ◆ readArrows()

bool BeagleWksDRParser::readArrows | ( |  | ) |
| protected

try to read the arrows zone (unknown format)

Referenced by BeagleWksDRParserInternal::SubDocument, and readGraphicHeader().

## ◆ readColors()

bool BeagleWksDRParser::readColors | ( |  | ) |
| protected

try to read the colors zone

Referenced by BeagleWksDRParserInternal::SubDocument, and readGraphicHeader().

## ◆ readGraphicHeader()

bool BeagleWksDRParser::readGraphicHeader | ( |  | ) |
| protected

try to read the graphic header

Referenced by BeagleWksDRParserInternal::SubDocument, and createZones().

## ◆ readPatterns()

bool BeagleWksDRParser::readPatterns | ( |  | ) |
| protected

try to read the pattern zone

Referenced by BeagleWksDRParserInternal::SubDocument, and readGraphicHeader().

## ◆ readPrintInfo()

bool BeagleWksDRParser::readPrintInfo | ( |  | ) |
| protected

read the print info zone

Referenced by BeagleWksDRParserInternal::SubDocument, checkHeader(), and createZones().

## ◆ readRSRCZones()

bool BeagleWksDRParser::readRSRCZones | ( |  | ) |
| protected

read the resource fork zone

Referenced by BeagleWksDRParserInternal::SubDocument, and createZones().

## ◆ readShapeDatas()

bool BeagleWksDRParser::readShapeDatas | ( |  | ) |
| protected

try to read the shape data

Referenced by BeagleWksDRParserInternal::SubDocument, and createZones().

## ◆ readShapeDefinitions()

bool BeagleWksDRParser::readShapeDefinitions | ( |  | ) |
| protected

try to read the shape definition

Referenced by BeagleWksDRParserInternal::SubDocument, and createZones().

## ◆ readShapePositions()

bool BeagleWksDRParser::readShapePositions | ( |  | ) |
| protected

try to read the shape position

Referenced by BeagleWksDRParserInternal::SubDocument, and readGraphicHeader().

## ◆ readStyle()

bool BeagleWksDRParser::readStyle | ( | BeagleWksDRParserInternal::Shape & | shape | ) |
| protected

try to read a style of a shape

Referenced by BeagleWksDRParserInternal::SubDocument, readGraphicHeader(), and readShapeDefinitions().

## ◆ rsrcAscii()

libmwaw::DebugFile & BeagleWksDRParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by BeagleWksDRParserInternal::SubDocument.

## ◆ rsrcInput()

MWAWInputStreamPtr BeagleWksDRParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by BeagleWksDRParserInternal::SubDocument.

## ◆ sendFrame()

bool BeagleWksDRParser::sendFrame | ( | BeagleWksStructManager::Frame const & | frame | ) |
| protected

try to send a frame

Referenced by BeagleWksDRParserInternal::SubDocument, and sendPageFrames().

## ◆ sendPageFrames()

bool BeagleWksDRParser::sendPageFrames | ( |  | ) |
| protected

try to send the page graphic

Referenced by BeagleWksDRParserInternal::SubDocument, and parse().

## ◆ sendPicture()

bool BeagleWksDRParser::sendPicture | ( | int | pId,
|  | MWAWPosition const & | pos,
|  | MWAWGraphicStyle const & | style = MWAWGraphicStyle::emptyStyle() )
| protected

try to send a picture

Referenced by BeagleWksDRParserInternal::SubDocument, and sendFrame().

## ◆ sendPictures()

bool BeagleWksDRParser::sendPictures | ( |  | ) |
| protected

try to send the different pictures

Referenced by BeagleWksDRParserInternal::SubDocument, and parse().

## ◆ sendText()

bool BeagleWksDRParser::sendText | ( | int | id | ) |
| protected

try to send a text box content

Referenced by BeagleWksDRParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## ◆ BeagleWksDRParserInternal::SubDocument

friend class BeagleWksDRParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<BeagleWksDRParserInternal::State> BeagleWksDRParser::m_state
| protected

the state

Referenced by BeagleWksDRParser(), checkHeader(), createDocument(), createZones(), getPageLeftTop(), init(), newPage(), readColors(), readGraphicHeader(), readPatterns(), readShapeDatas(), readShapeDefinitions(), readShapePositions(), readStyle(), sendPictures(), and sendText().

## ◆ m_structureManager

std::shared_ptr<BeagleWksStructManager> BeagleWksDRParser::m_structureManager
| protected

the structure manager

Referenced by BeagleWksDRParser(), createZones(), init(), readRSRCZones(), readStyle(), sendPageFrames(), and sendPicture().

The documentation for this class was generated from the following files:

- BeagleWksDRParser.hxx
- BeagleWksDRParser.cxx